<?php

define('DJO_VERSION', '1.21');

function djo_ausgabepuffer($ausgabetext = null) {
	global $djoAktenzeichenIgnorieren, $wgSitename, $wgEmergencyContact;
		if (!preg_match("/|&sect;|&#167;|Art\.|[\/\.] ?[0-9][0-9](?![0-9\/])| [0-9][0-9]?[\/\.] ?[0-9][0-9](?![0-9\.])| [A-Z]+ [0-9][0-9]\. ?[0-9]|[0-9][0-9],/", $ausgabetext) || preg_match("/<!-- *ohnedjo *-->/", $ausgabetext)) {
		return $ausgabetext;
	}

	// Aenderbare Variablen Anfang
	// ######################################################################
	$vernetzungscache = '/tmp/dejure.org/'; # Relativer oder absoluter Name eines (les- und beschreibbaren! - Attribute: etwa 744 oder 777) Verzeichnisses, mit abschlieendem "/" (bei leerer Variablen luft die Funktion ohne kein Cache)
	$anbieterkennung = $wgSitename; # Hier eine feste Bezeichnung fr Ihren Dienst zur Kommunikation mit dejure.org festlegen (Buchstaben und Zahlen erlaubt, mindestens 5 Stellen), Vorgabewert: Wiki-Name
	$kontaktemail = $wgEmergencyContact; # Wird im Rahmen der Serverkommunikation jeweils an dejure.org bertragen und dient im brigen ausschlielich der Kommunikation bei technischen Problemen. Statt des Vorgabewerts aus dem Wiki kann auch eine andere E-Mail-Adresse als String eingesetzt werden
	$target = ""; # Zum Beispiel fuer Oeffnen in neuem Fenster: "_blank"
	$class = "external"; # CSS-Klasse zum markieren externer Links. Bei der Wikimedia-Software ist es "external"
	$format = ""; # "schmal" oder "weit" verlinken. Nur die Nummern der Vorschriften verlinken (schmal, oder leer), oder moeglichst viel davon (weit)
	// ######################################################################
	// Aenderbare Variablen Ende

	if (!is_dir($vernetzungscache)) {
		mkdir($vernetzungscache, 0744);
	}
	$rueckgabe = vernetzen_ueber_cache($vernetzungscache, $ausgabetext);
	if (empty($rueckgabe)) {
		$rueckgabe = vernetzen_ueber_dejure_org($ausgabetext, $vernetzungscache, array("Anbieterkennung" => $anbieterkennung."__".$kontaktemail, "target" => $target, "class" => $class, "format" => $format, "version" => 'mediawiki-'.DJO_VERSION, "AktenzeichenIgnorieren" => $djoAktenzeichenIgnorieren));
	}
	if (date("G") < 6) { // Zwischen 0 und 6 Uhr ein mal alle Dateien im Cacheverzeichnis lschen, die lter als 4 Tage sind. Dies lst regelmig eine aktualisierende Neuvernetzung aus
		cache_dateien_loeschen($vernetzungscache, 96); // 4*24
	}
	return $rueckgabe;
}

function vernetzen_ueber_cache($vernetzungscache, $ausgangstext) {
	if (empty($vernetzungscache)) {
		return '';
	}
	$schluessel = strlen($ausgangstext).md5($ausgangstext);
	if (file_exists($vernetzungscache.$schluessel)) {
		if (filemtime($vernetzungscache.$schluessel) < time()-345600) { // 4*24*60*60
			return '';
		}
		return file_get_contents($vernetzungscache.$schluessel);
	}
	return '';
}

function ablegen_in_cache($vernetzungscache, $ausgangstext, $rueckgabe) {
	if (!empty($vernetzungscache)) {
		$schluessel = strlen($ausgangstext).md5($ausgangstext);
		$d = @fopen($vernetzungscache.$schluessel, "w");
		if ($d !== false) {
			fwrite($d, $rueckgabe);
			fclose($d);
		}
	}
}

function cache_dateien_loeschen($verzeichnis = null, $stunden = null) {
	if (empty($verzeichnis) || !is_numeric($stunden)) {
		return;
	}
	$verzeichnis.= '/';
	$verzeichnis = preg_replace("/\/\/+$/", "/", $verzeichnis);
	if (is_dir($verzeichnis)) {
		if (!file_exists($verzeichnis.'cache_status')) {
			cache_status_datei($verzeichnis);
			return;
		}
		$cache_status = file_get_contents($verzeichnis.'cache_status');
		if ((time() - $cache_status) > 8600) { // 24*60*60 -- Wenn das letzte Loeschen 24h her ist
			$dir_handle = opendir($verzeichnis);
			$geloescht = array();
			while (false !== ($datei = readdir($dir_handle))) {
				if (!in_array($datei, array('.', '..', 'vernetzungsfunction.inc.php'))) {
					$file_time = filemtime($verzeichnis.$datei);
					// Datei aelter als n Stunden, dann loeschen
					if ($file_time < (time() - $stunden * 3600)) {
						unlink($verzeichnis.$datei);
						$geloescht[] = $verzeichnis.$datei;
					}
				}
			}
			closedir($dir_handle);
			cache_status_datei($verzeichnis);
			return $geloescht;
		}
	}
}

function cache_status_datei($verzeichnis)
{
	$cache_zeitstempel = mktime(0, 0, 0, date('n'), date('j'), date('Y'));
	$file_handle = @fopen($verzeichnis.'cache_status', 'w');
	if ($file_handle) {
		fputs($file_handle, $cache_zeitstempel);
		fclose($file_handle);
	}
}

function integritaetskontrolle_und_cache($vernetzungscache, $ausgangstext, $neuertext) {
	if (preg_replace("/<a href=\"http:\/\/dejure.org\/[^>]*>([^<]*)<\/a>/i", "\\1", $ausgangstext) == preg_replace("/<a href=\"http:\/\/dejure.org\/[^>]*>([^<]*)<\/a>/i", "\\1", $neuertext)) {
		ablegen_in_cache($vernetzungscache, $ausgangstext, $neuertext);
		return $neuertext;
	}
	else {
		return $ausgangstext;
	}
}

function vernetzen_ueber_dejure_org($ausgangstext, $vernetzungscache, $parameter = array()) {
	// Mgliche Parameter: Anbieterkennung / Dokumentkennung / target / class / AktenzeichenIgnorieren / zeitlimit_in_sekunden
	// Hinweis: Bei nderung der Einstellungen mu der Cache manuell gelscht werden
	$uebergabe = "Originaltext=".urlencode($ausgangstext);
	foreach ($parameter as $option => $wert) {
		if ($option == 'zeitlimit_in_sekunden') {
			$zeitlimit_in_sekunden = $wert;
		}
		else {
			$uebergabe .= "&".urlencode($option)."=".urlencode($wert);
		}
	}
	if (!isset($zeitlimit_in_sekunden)) {
		$zeitlimit_in_sekunden = 3;
	}
	$header = "POST http://rechtsnetz.dejure.org/dienste/vernetzung/vernetzen HTTP/1.0\r\n";
	$header .= "Content-type: application/x-www-form-urlencoded\r\n";
	$header .= "Content-length: " . strlen($uebergabe) . "\r\n\r\n";

	$fp = @fsockopen("rechtsnetz.dejure.org", 80, $errno, $errstr, 12);

	if (!$fp) { // Verbindung gescheitert
		return $ausgangstext;
	}
	else {
		socket_set_timeout($fp, $zeitlimit_in_sekunden, 0); // Socket nach $zeitlimit_in_sekunden Sekunden auf jeden Fall wieder frei geben
		socket_set_blocking($fp, true);
		fputs($fp, $header.$uebergabe);
		$timeOutSock = false;
		$eofSock = false;
		$rueckgabe = '';
		while (!$eofSock && !$timeOutSock) {
			$rueckgabe.= fgets($fp, 1024); //
			$stSock = socket_get_status($fp);
			$eofSock = $stSock["eof"];
			$timeOutSock = $stSock["timed_out"];
		}
		fclose($fp);
		if (!preg_match("/^(.*?)\r?\n\r?\n\r?\n?(.*)/s",$rueckgabe, $rueckgabeARR)) {
			return $ausgangstext; // Zeitberschreitung oder Verbindungsproblem
		}
		else if (strpos($rueckgabeARR[1],"200 OK")===false) {
			return $ausgangstext; // sonstiges Serverproblem
		}
		else {
			$rueckgabe = $rueckgabeARR[2];
			if (strlen($rueckgabe) < strlen($ausgangstext)) {
				return $ausgangstext;
			}
			return integritaetskontrolle_und_cache($vernetzungscache, $ausgangstext, $rueckgabe);
		}
	}
}
?>
